<div class="flex-column">
  <section class="pageheadsection mob-pageheadsection1">
    <div class="mdl-grid mdl-grid.mdl-grid--no-spacing">
      <div>
        <gp-headline [headlineTitle]="'My Models'"></gp-headline>
      </div>
      <gp-breadcrumb-navigation
        [firstNavigationLabel]="{ label: 'Home' }"
        [secondNavigationLabel]="{ label: 'My models', disabled: true }"
        (firstNavigationClicked)="onHomeClick()"
      ></gp-breadcrumb-navigation>
    </div>
  </section>
  <mat-sidenav-container>
    <mat-sidenav mode="side" opened>
      <gp-filters
        [tags]="tags"
        [categories]="categories"
        (selectedTagsChange)="handleSelectedTagsChange($event)"
        (selectedCategoriesChange)="handleSelectedCategoriesChange($event)"
        (searchValueChanged)="onSearchValueChanged($event)"
      ></gp-filters>
    </mat-sidenav>
    <mat-sidenav-content class="page-wrap">
      <main class="content-router-outlet">
        <div class="content-container">
          <div class="sort-toggle-container">
            <div class="gp-sort-by">
              <gp-sort-by
                [sortByOptions]="sortByOptions"
                [selectedSortBy]="sortByFilter"
                (sortBySelected)="updateFieldToDirectionMap($event)"
              ></gp-sort-by>
            </div>
            <div class="gp-card-list-view">
              <gp-solutions-toggle-view
                [viewTile]="viewTile"
                (viewTileChange)="onViewTileChange($event)"
              ></gp-solutions-toggle-view>
            </div>
          </div>
          <!--Unpublished models section-->
          @if (modelType === "both") {
            <div class="flex-column">
              <gp-model-list
                [solutions]="selectedUnpublishedSolutions"
                [totalItems]="unpublishedTotalItems"
                [isLoading]="isUnpublishedSolutionsLoading"
                [headlineTitle]="'MY UNPUBLISHED MODELS'"
                [showEntirePage]="false"
                [viewTile]="viewTile"
                [pageSize]="pageSize"
                [pageIndex]="pageIndex"
                [pageSizeOptions]="pageSizeOptions"
                [modelType]="'unpublished'"
                [favoriteSolutionsMap]="favoriteSolutionsMap"
                [calculateStartIndex]="calculateStartIndex(pageIndex, pageSize)"
                [calculateEndIndex]="
                  calculateEndIndex(unpublishedTotalItems, pageIndex, pageSize)
                "
                (pageChange)="onPageChange($event)"
                (updateFavorite)="updateFavorite($event)"
                (backEvent)="onClickBack('both')"
              ></gp-model-list>

              <div class="see-all-container">
                <button
                  class="see-all-button"
                  aria-label="icon button with a menu icon"
                  (click)="onClickSeeAll('unpublished')"
                >
                  <div class="see-all-text-container">
                    <span>See all</span> <mat-icon>arrow_forward_ios</mat-icon>
                  </div>
                </button>
              </div>
            </div>
          }

          @if (modelType === "unpublished") {
            <div class="flex-column">
              <gp-model-list
                [solutions]="selectedUnpublishedSolutions"
                [totalItems]="unpublishedTotalItems"
                [isLoading]="isUnpublishedSolutionsLoading"
                [headlineTitle]="'MY UNPUBLISHED MODELS'"
                [showEntirePage]="true"
                [viewTile]="viewTile"
                [pageSize]="pageSize"
                [pageIndex]="pageIndex"
                [pageSizeOptions]="pageSizeOptions"
                [modelType]="'unpublished'"
                [favoriteSolutionsMap]="favoriteSolutionsMap"
                [calculateStartIndex]="calculateStartIndex(pageIndex, pageSize)"
                [calculateEndIndex]="
                  calculateEndIndex(unpublishedTotalItems, pageIndex, pageSize)
                "
                (pageChange)="onPageChange($event)"
                (updateFavorite)="updateFavorite($event)"
                (backEvent)="onClickBack('both')"
              ></gp-model-list>
            </div>
          }

          <!--published solutions -->

          @if (modelType === "both") {
            <div class="flex-column">
              <gp-model-list
                [solutions]="selectedPublishedSolutions"
                [totalItems]="publishedTotalItems"
                [isLoading]="isPublishedSolutionsLoading"
                [headlineTitle]="'MY PUBLISHED MODELS'"
                [showEntirePage]="false"
                [viewTile]="viewTile"
                [pageSize]="pageSize"
                [pageIndex]="pageIndex"
                [pageSizeOptions]="pageSizeOptions"
                [modelType]="'published'"
                [favoriteSolutionsMap]="favoriteSolutionsMap"
                [calculateStartIndex]="calculateStartIndex(pageIndex, pageSize)"
                [calculateEndIndex]="
                  calculateEndIndex(publishedTotalItems, pageIndex, pageSize)
                "
                (pageChange)="onPageChange($event)"
                (updateFavorite)="updateFavorite($event)"
                (backEvent)="onClickBack('both')"
              ></gp-model-list>

              <div class="see-all-container">
                <button
                  class="see-all-button"
                  aria-label="Example icon button with a menu icon"
                  (click)="onClickSeeAll('published')"
                >
                  <div class="see-all-text-container">
                    <span>See all</span> <mat-icon>arrow_forward_ios</mat-icon>
                  </div>
                </button>
              </div>
            </div>
          }
          @if (modelType === "published") {
            <div class="flex-column">
              <gp-model-list
                [solutions]="selectedPublishedSolutions"
                [totalItems]="publishedTotalItems"
                [isLoading]="isPublishedSolutionsLoading"
                [headlineTitle]="'MY PUBLISHED MODELS'"
                [showEntirePage]="true"
                [viewTile]="viewTile"
                [pageSize]="pageSize"
                [pageIndex]="pageIndex"
                [pageSizeOptions]="pageSizeOptions"
                [modelType]="'published'"
                [favoriteSolutionsMap]="favoriteSolutionsMap"
                [calculateStartIndex]="calculateStartIndex(pageIndex, pageSize)"
                [calculateEndIndex]="
                  calculateEndIndex(publishedTotalItems, pageIndex, pageSize)
                "
                (pageChange)="onPageChange($event)"
                (updateFavorite)="updateFavorite($event)"
                (backEvent)="onClickBack('both')"
              ></gp-model-list>
            </div>
          }
        </div>
      </main> </mat-sidenav-content
  ></mat-sidenav-container>
</div>
